=== modified file 'DBUS-API'
--- DBUS-API	2011-11-24 19:09:29 +0000
+++ DBUS-API	2011-10-02 19:18:24 +0000
@@ -152,9 +152,6 @@
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
-*** NewRequest(s: IP address)
-    A client at IP adress has asked for its password.
-
 * Copyright
 
     Copyright © 2010-2011 Teddy Hogeborn

=== modified file 'Makefile'
--- Makefile	2011-11-26 20:59:56 +0000
+++ Makefile	2011-10-15 16:48:03 +0000
@@ -260,8 +260,13 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	./mandos --debug --no-dbus --configdir=confdir --no-restore \
-	$(SERVERARGS)
+	@echo "#################################################################"
+	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
+	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
+	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
+	@echo "# server as root if you didn't also unpack and compile it thus. #"
+	@echo "#################################################################"
+	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf

=== modified file 'TODO'
--- TODO	2011-11-09 17:16:03 +0000
+++ TODO	2011-10-14 18:00:50 +0000
@@ -41,7 +41,8 @@
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
-  
+** TODO Persistent state						  :BUGS:
+   /var/lib/mandos/*
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
@@ -52,6 +53,8 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Date+time on console log messages				  :BUGS:
+   Is this the default?
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given
@@ -65,6 +68,7 @@
    http://0pointer.de/blog/projects/systemd.html
    http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
+** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra

=== modified file 'debian/control'
--- debian/control	2011-11-26 20:59:56 +0000
+++ debian/control	2011-10-11 19:36:00 +0000
@@ -17,8 +17,7 @@
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.7) | python-argparse,
-	python-gnupginterface
+	python-urwid, python (>=2.7) | python-argparse
 Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'mandos'
--- mandos	2011-11-26 20:59:56 +0000
+++ mandos	2011-10-15 16:48:03 +0000
@@ -63,8 +63,6 @@
 import cPickle as pickle
 import multiprocessing
 import types
-import binascii
-import tempfile
 
 import dbus
 import dbus.service
@@ -75,7 +73,6 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
-import GnuPGInterface
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -87,125 +84,22 @@
 
 
 version = "1.4.1"
-stored_state_path = "/var/lib/mandos/clients.pickle"
 
-logger = logging.getLogger()
+#logger = logging.getLogger('mandos')
+logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = str("/dev/log")))
-
-try:
-    if_nametoindex = (ctypes.cdll.LoadLibrary
-                      (ctypes.util.find_library("c"))
-                      .if_nametoindex)
-except (OSError, AttributeError):
-    def if_nametoindex(interface):
-        "Get an interface index the hard way, i.e. using fcntl()"
-        SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-        with contextlib.closing(socket.socket()) as s:
-            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(str("16s16x"),
-                                            interface))
-        interface_index = struct.unpack(str("I"),
-                                        ifreq[16:20])[0]
-        return interface_index
-
-
-def initlogger(level=logging.WARNING):
-    """init logger and add loglevel"""
-    
-    syslogger.setFormatter(logging.Formatter
-                           ('Mandos [%(process)d]: %(levelname)s:'
-                            ' %(message)s'))
-    logger.addHandler(syslogger)
-    
-    console = logging.StreamHandler()
-    console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                           ' [%(process)d]:'
-                                           ' %(levelname)s:'
-                                           ' %(message)s'))
-    logger.addHandler(console)
-    logger.setLevel(level)
-
-
-class CryptoError(Exception):
-    pass
-
-
-class Crypto(object):
-    """A simple class for OpenPGP symmetric encryption & decryption"""
-    def __init__(self):
-        self.gnupg = GnuPGInterface.GnuPG()
-        self.tempdir = tempfile.mkdtemp(prefix="mandos-")
-        self.gnupg = GnuPGInterface.GnuPG()
-        self.gnupg.options.meta_interactive = False
-        self.gnupg.options.homedir = self.tempdir
-        self.gnupg.options.extra_args.extend(['--force-mdc',
-                                              '--quiet'])
-    
-    def __enter__(self):
-        return self
-    
-    def __exit__ (self, exc_type, exc_value, traceback):
-        self._cleanup()
-        return False
-    
-    def __del__(self):
-        self._cleanup()
-    
-    def _cleanup(self):
-        if self.tempdir is not None:
-            # Delete contents of tempdir
-            for root, dirs, files in os.walk(self.tempdir,
-                                             topdown = False):
-                for filename in files:
-                    os.remove(os.path.join(root, filename))
-                for dirname in dirs:
-                    os.rmdir(os.path.join(root, dirname))
-            # Remove tempdir
-            os.rmdir(self.tempdir)
-            self.tempdir = None
-    
-    def password_encode(self, password):
-        # Passphrase can not be empty and can not contain newlines or
-        # NUL bytes.  So we prefix it and hex encode it.
-        return b"mandos" + binascii.hexlify(password)
-    
-    def encrypt(self, data, password):
-        self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull) as devnull:
-            try:
-                proc = self.gnupg.run(['--symmetric'],
-                                      create_fhs=['stdin', 'stdout'],
-                                      attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin']) as f:
-                    f.write(data)
-                with contextlib.closing(proc.handles['stdout']) as f:
-                    ciphertext = f.read()
-                proc.wait()
-            except IOError as e:
-                raise CryptoError(e)
-        self.gnupg.passphrase = None
-        return ciphertext
-    
-    def decrypt(self, data, password):
-        self.gnupg.passphrase = self.password_encode(password)
-        with open(os.devnull) as devnull:
-            try:
-                proc = self.gnupg.run(['--decrypt'],
-                                      create_fhs=['stdin', 'stdout'],
-                                      attach_fhs={'stderr': devnull})
-                with contextlib.closing(proc.handles['stdin'] ) as f:
-                    f.write(data)
-                with contextlib.closing(proc.handles['stdout']) as f:
-                    decrypted_plaintext = f.read()
-                proc.wait()
-            except IOError as e:
-                raise CryptoError(e)
-        self.gnupg.passphrase = None
-        return decrypted_plaintext
-
-
+syslogger.setFormatter(logging.Formatter
+                       ('Mandos [%(process)d]: %(levelname)s:'
+                        ' %(message)s'))
+logger.addHandler(syslogger)
+
+console = logging.StreamHandler()
+console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
+                                       ' %(levelname)s:'
+                                       ' %(message)s'))
+logger.addHandler(console)
 
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
@@ -270,6 +164,10 @@
                             .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
         self.remove()
         try:
             self.add()
@@ -295,7 +193,7 @@
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
         self.entry_group_state_changed_match = (
             self.group.connect_to_signal(
-                'StateChanged', self.entry_group_state_changed))
+                'StateChanged', self .entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -327,7 +225,7 @@
             try:
                 self.group.Free()
             except (dbus.exceptions.UnknownMethodException,
-                    dbus.exceptions.DBusException):
+                    dbus.exceptions.DBusException) as e:
                 pass
             self.group = None
         self.remove()
@@ -367,15 +265,6 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
-class AvahiServiceToSyslog(AvahiService):
-    def rename(self):
-        """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % self.name))
-        return ret
 
 def _timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
@@ -400,9 +289,8 @@
                      instance %(name)s can be used in the command.
     checker_initiator_tag: a gobject event source tag, or None
     created:    datetime.datetime(); (UTC) object creation
-    client_structure: Object describing what attributes a client has
-                      and is used for storing the client at exit
     current_checker_command: string; current running checker_command
+    disable_hook:  If set, called by disable() as disable_hook(self)
     disable_initiator_tag: a gobject event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
@@ -411,10 +299,6 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
-
-    last_checker_status: integer between 0 and 255 reflecting exit
-                         status of last checker. -1 reflects crashed
-                         checker, or None.
     last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
@@ -447,7 +331,7 @@
     def approval_delay_milliseconds(self):
         return _timedelta_to_milliseconds(self.approval_delay)
     
-    def __init__(self, name = None, config=None):
+    def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
@@ -473,22 +357,23 @@
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
-        self.enabled = True
+        self.enabled = False
         self.last_approval_request = None
-        self.last_enabled = datetime.datetime.utcnow()
+        self.last_enabled = None
         self.last_checked_ok = None
-        self.last_checker_status = None
         self.timeout = string_to_delta(config["timeout"])
         self.extended_timeout = string_to_delta(config
                                                 ["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
+        self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
-        self.expires = datetime.datetime.utcnow() + self.timeout
+        self.expires = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
+        self.last_connect = None
         self._approved = None
         self.approved_by_default = config.get("approved_by_default",
                                               True)
@@ -500,22 +385,11 @@
         self.changedstate = (multiprocessing_manager
                              .Condition(multiprocessing_manager
                                         .Lock()))
-        self.client_structure = [attr for attr in
-                                 self.__dict__.iterkeys()
-                                 if not attr.startswith("_")]
-        self.client_structure.append("client_structure")
-        
-        for name, t in inspect.getmembers(type(self),
-                                          lambda obj:
-                                              isinstance(obj,
-                                                         property)):
-            if not name.startswith("_"):
-                self.client_structure.append(name)
     
-    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        with self.changedstate:
-            self.changedstate.notify_all()
+        self.changedstate.acquire()
+        self.changedstate.notify_all()
+        self.changedstate.release()
     
     def enable(self):
         """Start this client's checker and timeout hooks"""
@@ -523,10 +397,20 @@
             # Already enabled
             return
         self.send_changedstate()
+        # Schedule a new checker to be started an 'interval' from now,
+        # and every interval from then on.
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (self.interval_milliseconds(),
+                                       self.start_checker))
+        # Schedule a disable() when 'timeout' has passed
         self.expires = datetime.datetime.utcnow() + self.timeout
+        self.disable_initiator_tag = (gobject.timeout_add
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
-        self.init_checker()
+        # Also start a new checker *right now*.
+        self.start_checker()
     
     def disable(self, quiet=True):
         """Disable this client."""
@@ -544,33 +428,23 @@
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
+        if self.disable_hook:
+            self.disable_hook(self)
         self.enabled = False
         # Do not run this again if called by a gobject.timeout_add
         return False
     
     def __del__(self):
+        self.disable_hook = None
         self.disable()
     
-    def init_checker(self):
-        # Schedule a new checker to be started an 'interval' from now,
-        # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
-        # Schedule a disable() when 'timeout' has passed
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
-        # Also start a new checker *right now*.
-        self.start_checker()
-    
     def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            self.last_checker_status =  os.WEXITSTATUS(condition)
-            if self.last_checker_status == 0:
+            exitstatus = os.WEXITSTATUS(condition)
+            if exitstatus == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
@@ -578,7 +452,6 @@
                 logger.info("Checker for %(name)s failed",
                             vars(self))
         else:
-            self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
@@ -818,7 +691,7 @@
         
         Note: Will not include properties with access="write".
         """
-        properties = {}
+        all = {}
         for name, prop in self._get_all_dbus_properties():
             if (interface_name
                 and interface_name != prop._dbus_interface):
@@ -829,11 +702,11 @@
                 continue
             value = prop()
             if not hasattr(value, "variant_level"):
-                properties[name] = value
+                all[name] = value
                 continue
-            properties[name] = type(value)(value, variant_level=
-                                           value.variant_level+1)
-        return dbus.Dictionary(properties, signature="sv")
+            all[name] = type(value)(value, variant_level=
+                                    value.variant_level+1)
+        return dbus.Dictionary(all, signature="sv")
     
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
@@ -890,7 +763,6 @@
     return dbus.String(dt.isoformat(),
                        variant_level=variant_level)
 
-
 class AlternateDBusNamesMetaclass(DBusObjectWithProperties
                                   .__metaclass__):
     """Applied to an empty subclass of a D-Bus object, this metaclass
@@ -988,7 +860,6 @@
                                         attribute.func_closure)))
         return type.__new__(mcs, name, bases, attr)
 
-
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -1003,10 +874,9 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
+        self._approvals_pending = 0
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
-        
-        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -1022,7 +892,7 @@
                              variant_level=1):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
-        
+
         transform_fun: Function that takes a value and a variant_level
                        and transforms it to a D-Bus type.
         dbus_name: D-Bus name of the variable
@@ -1182,14 +1052,6 @@
         "D-Bus signal"
         return self.need_approval()
     
-    # NeRwequest - signal
-    @dbus.service.signal(_interface, signature="s")
-    def NewRequest(self, ip):
-        """D-Bus signal
-        Is sent after a client request a password.
-        """
-        pass
-    
     ## Methods
     
     # Approve - method
@@ -1424,11 +1286,9 @@
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
-
 class ClientDBusTransitional(ClientDBus):
     __metaclass__ = AlternateDBusNamesMetaclass
 
-
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
     
@@ -1495,9 +1355,6 @@
                     logger.warning("Bad certificate: %s", error)
                     return
                 logger.debug("Fingerprint: %s", fpr)
-                if self.server.use_dbus:
-                    # Emit D-Bus signal
-                    client.NewRequest(str(self.client_address))
                 
                 try:
                     client = ProxyClient(child_pipe, fpr,
@@ -1647,7 +1504,7 @@
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
-        hex_fpr = binascii.hexlify(fpr).upper()
+        hex_fpr = ''.join("%02X" % ord(char) for char in fpr)
         return hex_fpr
 
 
@@ -1767,7 +1624,7 @@
         self.enabled = False
         self.clients = clients
         if self.clients is None:
-            self.clients = {}
+            self.clients = set()
         self.use_dbus = use_dbus
         self.gnutls_priority = gnutls_priority
         IPv6_TCPServer.__init__(self, server_address,
@@ -1820,7 +1677,7 @@
             fpr = request[1]
             address = request[2]
             
-            for c in self.clients.itervalues():
+            for c in self.clients:
                 if c.fingerprint == fpr:
                     client = c
                     break
@@ -1910,6 +1767,30 @@
     return timevalue
 
 
+def if_nametoindex(interface):
+    """Call the C function if_nametoindex(), or equivalent
+    
+    Note: This function cannot accept a unicode string."""
+    global if_nametoindex
+    try:
+        if_nametoindex = (ctypes.cdll.LoadLibrary
+                          (ctypes.util.find_library("c"))
+                          .if_nametoindex)
+    except (OSError, AttributeError):
+        logger.warning("Doing if_nametoindex the hard way")
+        def if_nametoindex(interface):
+            "Get an interface index the hard way, i.e. using fcntl()"
+            SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
+            with contextlib.closing(socket.socket()) as s:
+                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                    struct.pack(str("16s16x"),
+                                                interface))
+            interface_index = struct.unpack(str("I"),
+                                            ifreq[16:20])[0]
+            return interface_index
+    return if_nametoindex(interface)
+
+
 def daemon(nochdir = False, noclose = False):
     """See daemon(3).  Standard BSD Unix function.
     
@@ -1970,10 +1851,6 @@
                         " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
                         dest="use_ipv6", help="Do not use IPv6")
-    parser.add_argument("--no-restore", action="store_false",
-                        dest="restore", help="Do not restore stored"
-                        " state", default=True)
-    
     options = parser.parse_args()
     
     if options.check:
@@ -2014,7 +1891,7 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore"):
+                   "use_dbus", "use_ipv6", "debuglevel"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2033,15 +1910,6 @@
     use_dbus = server_settings["use_dbus"]
     use_ipv6 = server_settings["use_ipv6"]
     
-    if debug:
-        initlogger(logging.DEBUG)
-    else:
-        if not debuglevel:
-            initlogger()
-        else:
-            level = getattr(logging, debuglevel.upper())
-            initlogger(level)
-    
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
                                ('Mandos (%s) [%%(process)d]:'
@@ -2101,6 +1969,14 @@
         if error[0] != errno.EPERM:
             raise error
     
+    if not debug and not debuglevel:
+        syslogger.setLevel(logging.WARNING)
+        console.setLevel(logging.WARNING)
+    if debuglevel:
+        level = getattr(logging, debuglevel.upper())
+        syslogger.setLevel(level)
+        console.setLevel(level)
+    
     if debug:
         # Enable all possible GnuTLS debugging
         
@@ -2148,10 +2024,9 @@
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiServiceToSyslog(name =
-                                   server_settings["servicename"],
-                                   servicetype = "_mandos._tcp",
-                                   protocol = protocol, bus = bus)
+    service = AvahiService(name = server_settings["servicename"],
+                           servicetype = "_mandos._tcp",
+                           protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings["interface"])))
@@ -2163,128 +2038,23 @@
     if use_dbus:
         client_class = functools.partial(ClientDBusTransitional,
                                          bus = bus)
-    
-    special_settings = {
-        # Some settings need to be accessd by special methods;
-        # booleans need .getboolean(), etc.  Here is a list of them:
-        "approved_by_default":
-            lambda section:
-            client_config.getboolean(section, "approved_by_default"),
-        }
-    # Construct a new dict of client settings of this form:
-    # { client_name: {setting_name: value, ...}, ...}
-    # with exceptions for any special settings as defined above
-    client_settings = dict((clientname,
-                           dict((setting,
-                                 (value
-                                  if setting not in special_settings
-                                  else special_settings[setting]
-                                  (clientname)))
-                                for setting, value in
-                                client_config.items(clientname)))
-                          for clientname in client_config.sections())
-    
-    old_client_settings = {}
-    clients_data = []
-    
-    # Get client data and settings from last running state.
-    if server_settings["restore"]:
-        try:
-            with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = (pickle.load
-                                                     (stored_state))
-            os.remove(stored_state_path)
-        except IOError as e:
-            logger.warning("Could not load persistent state: {0}"
-                           .format(e))
-            if e.errno != errno.ENOENT:
-                raise
-    
-    with Crypto() as crypt:
-        for client in clients_data:
-            client_name = client["name"]
-            
-            # Decide which value to use after restoring saved state.
-            # We have three different values: Old config file,
-            # new config file, and saved state.
-            # New config value takes precedence if it differs from old
-            # config value, otherwise use saved state.
-            for name, value in client_settings[client_name].items():
-                try:
-                    # For each value in new config, check if it
-                    # differs from the old config value (Except for
-                    # the "secret" attribute)
-                    if (name != "secret" and
-                        value != old_client_settings[client_name]
-                        [name]):
-                        setattr(client, name, value)
-                except KeyError:
-                    pass
-            
-            # Clients who has passed its expire date can still be
-            # enabled if its last checker was sucessful.  Clients
-            # whose checker failed before we stored its state is
-            # assumed to have failed all checkers during downtime.
-            if client["enabled"] and client["last_checked_ok"]:
-                if ((datetime.datetime.utcnow()
-                     - client["last_checked_ok"])
-                    > client["interval"]):
-                    if client["last_checker_status"] != 0:
-                        client["enabled"] = False
-                    else:
-                        client["expires"] = (datetime.datetime
-                                             .utcnow()
-                                             + client["timeout"])
-            
-            client["changedstate"] = (multiprocessing_manager
-                                      .Condition
-                                      (multiprocessing_manager
-                                       .Lock()))
-            if use_dbus:
-                new_client = (ClientDBusTransitional.__new__
-                              (ClientDBusTransitional))
-                tcp_server.clients[client_name] = new_client
-                new_client.bus = bus
-                for name, value in client.iteritems():
-                    setattr(new_client, name, value)
-                client_object_name = unicode(client_name).translate(
-                    {ord("."): ord("_"),
-                     ord("-"): ord("_")})
-                new_client.dbus_object_path = (dbus.ObjectPath
-                                               ("/clients/"
-                                                + client_object_name))
-                DBusObjectWithProperties.__init__(new_client,
-                                                  new_client.bus,
-                                                  new_client
-                                                  .dbus_object_path)
-            else:
-                tcp_server.clients[client_name] = (Client.__new__
-                                                   (Client))
-                for name, value in client.iteritems():
-                    setattr(tcp_server.clients[client_name],
-                            name, value)
-            
+    def client_config_items(config, section):
+        special_settings = {
+            "approved_by_default":
+                lambda: config.getboolean(section,
+                                          "approved_by_default"),
+            }
+        for name, value in config.items(section):
             try:
-                tcp_server.clients[client_name].secret = (
-                    crypt.decrypt(tcp_server.clients[client_name]
-                                  .encrypted_secret,
-                                  client_settings[client_name]
-                                  ["secret"]))
-            except CryptoError:
-                # If decryption fails, we use secret from new settings
-                tcp_server.clients[client_name].secret = (
-                    client_settings[client_name]["secret"])
-    
-    # Create/remove clients based on new changes made to config
-    for clientname in set(old_client_settings) - set(client_settings):
-        del tcp_server.clients[clientname]
-    for clientname in set(client_settings) - set(old_client_settings):
-        tcp_server.clients[clientname] = (client_class(name
-                                                       = clientname,
-                                                       config =
-                                                       client_settings
-                                                       [clientname]))
-    
+                yield (name, special_settings[name]())
+            except KeyError:
+                yield (name, value)
+    
+    tcp_server.clients.update(set(
+            client_class(name = section,
+                         config= dict(client_config_items(
+                        client_config, section)))
+            for section in client_config.sections()))
     if not tcp_server.clients:
         logger.warning("No clients defined")
         
@@ -2333,8 +2103,7 @@
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
-                                  for c in
-                                  tcp_server.clients.itervalues())
+                                  for c in tcp_server.clients)
             
             @dbus.service.method(_interface,
                                  out_signature="a{oa{sv}}")
@@ -2342,15 +2111,15 @@
                 "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAll(""))
-                     for c in tcp_server.clients.itervalues()),
+                     for c in tcp_server.clients),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
-                for c in tcp_server.clients.itervalues():
+                for c in tcp_server.clients:
                     if c.dbus_object_path == object_path:
-                        del tcp_server.clients[c.name]
+                        tcp_server.clients.remove(c)
                         c.remove_from_connection()
                         # Don't signal anything except ClientRemoved
                         c.disable(quiet=True)
@@ -2370,52 +2139,11 @@
         service.cleanup()
         
         multiprocessing.active_children()
-        if not (tcp_server.clients or client_settings):
-            return
-        
-        # Store client before exiting. Secrets are encrypted with key
-        # based on what config file has. If config file is
-        # removed/edited, old secret will thus be unrecovable.
-        clients = []
-        with Crypto() as crypt:
-            for client in tcp_server.clients.itervalues():
-                key = client_settings[client.name]["secret"]
-                client.encrypted_secret = crypt.encrypt(client.secret,
-                                                        key)
-                client_dict = {}
-                
-                # A list of attributes that will not be stored when
-                # shutting down.
-                exclude = set(("bus", "changedstate", "secret"))
-                for name, typ in (inspect.getmembers
-                                  (dbus.service.Object)):
-                    exclude.add(name)
-                
-                client_dict["encrypted_secret"] = (client
-                                                   .encrypted_secret)
-                for attr in client.client_structure:
-                    if attr not in exclude:
-                        client_dict[attr] = getattr(client, attr)
-                
-                clients.append(client_dict)
-                del client_settings[client.name]["secret"]
-        
-        try:
-            with os.fdopen(os.open(stored_state_path,
-                                   os.O_CREAT|os.O_WRONLY|os.O_TRUNC,
-                                   0600), "wb") as stored_state:
-                pickle.dump((clients, client_settings), stored_state)
-        except (IOError, OSError) as e:
-            logger.warning("Could not save persistent state: {0}"
-                           .format(e))
-            if e.errno not in (errno.ENOENT, errno.EACCES):
-                raise
-        
-        # Delete all clients, and settings from config
         while tcp_server.clients:
-            name, client = tcp_server.clients.popitem()
+            client = tcp_server.clients.pop()
             if use_dbus:
                 client.remove_from_connection()
+            client.disable_hook = None
             # Don't signal anything except ClientRemoved
             client.disable(quiet=True)
             if use_dbus:
@@ -2423,17 +2151,14 @@
                 mandos_dbus_service.ClientRemoved(client
                                                   .dbus_object_path,
                                                   client.name)
-        client_settings.clear()
     
     atexit.register(cleanup)
     
-    for client in tcp_server.clients.itervalues():
+    for client in tcp_server.clients:
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path)
-        # Need to initiate checking of clients
-        if client.enabled:
-            client.init_checker()
+        client.enable()
     
     tcp_server.enable()
     tcp_server.server_activate()

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2011-11-09 17:16:03 +0000
+++ mandos-options.xml	2009-02-13 05:38:21 +0000
@@ -85,10 +85,5 @@
     to the server if this option is turned off.  <emphasis>Only
     advanced users should consider changing this option</emphasis>.
   </para>
-
-  <para id="restore">
-    This option controls whether the server will restore any state from
-    last time it ran. Default is to try restore last state.
-  </para>
   
 </section>

=== modified file 'mandos.xml'
--- mandos.xml	2011-11-09 17:16:03 +0000
+++ mandos.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-10-22">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -94,8 +94,6 @@
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
-      <sbr/>
-      <arg><option>--no-restore</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -277,13 +275,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--no-restore</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -518,6 +509,9 @@
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
+      The console log messages do not show a time stamp.
+    </para>
+    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>

